// Dart imports:
import 'dart:async';

// Project imports:
import 'package:zego_uikit/zego_uikit.dart';

mixin ZegoUIKitNotificationPluginService {
  Future<ZegoSignalingPluginResult>
      enableNotifyWhenAppRunningInBackgroundOrQuit(
    bool enabled, {
    bool isIOSSandboxEnvironment = false,
  }) async {
    Map result = await ZegoUIKit()
        .getPlugin(ZegoUIKitPluginType.signaling)!
        .invoke('enableNotifyWhenAppRunningInBackgroundOrQuit', {
      'enabled': enabled,
      'isIOSSandboxEnvironment': isIOSSandboxEnvironment,
    });

    return ZegoSignalingPluginResult(
      result['errorCode'] as String,
      result['errorMessage'] as String,
    );
  }
}
