part of 'zego_uikit_core.dart';

extension ZegoUIKitCorePlugin on ZegoUIKitCore {
  void installPlugins(List<IZegoUIKitPlugin> instances) {
    for (var item in instances) {
      ZegoUIKitPluginType itemType = item.getPluginType();
      if (plugins[itemType] != null) {
        ZegoLoggerService.logInfo(
          "plugin type:$itemType already exists, will update plugin instance",
          tag: "uikit",
          subTag: "core plugin",
        );
      }
      plugins[itemType] = item;
      ZegoLoggerService.logInfo(
        "installed $itemType",
        tag: "uikit",
        subTag: "core plugin",
      );
    }
  }
}
